module.exports = fixAdminPart

function fixAdminPart (state, next) {
  state.couch.session(function (error, session) {
    /* istanbul ignore if */
    if (error) {
      return next(error)
    }

    // no admin party if user doesn't have admin role
    if (session.userCtx.roles.indexOf('_admin') === -1) {
      return next()
    }

    state.couch.request({
      method: 'put',
      path: '_config/admins/' + state.config.admin.username,
      body: state.config.admin.password
    }, function (error) {
      /* istanbul ignore if */
      if (error) {
        return next(error)
      }

      state.log([state.name, 'bootstrap', 'info'], 'admin user created: ' + state.config.admin.username)
      next()
    })
  })
}
