var path = require('path')
var test = require('tap').test
var startServer = require('kazana-server')

var bootstrap = require('../..')

var serverOptions = {
  name: 'test',
  config: {
    kazana: {
      backend: {
        name: 'memdown',
        port: 5999
      }
    }
  }
}

test('bootstrap', function (group) {
  group.test('bootstrap a database', function (t) {
    startServer(serverOptions, function (error, server) {
      t.error(error)
      var bootstrapOptions = {
        name: serverOptions.name,
        bootstrapPath: path.join(__dirname, '../fixtures'),
        config: server.settings.app,
        couchUrl: server.methods.getCouchUrl(),
        log: server.log.bind(server)
      }
      bootstrap(bootstrapOptions, function (error) {
        t.error(error)
        server.app.admin.rawData.db.get('bootstrapped-document')
          .then(function (doc) {
            t.equal(doc._id, 'bootstrapped-document', 'there is a `bootstrapped-document` doc')
          })
          .then(server.stop.bind(null, t.end))
      })
    })
  })

  group.end()
})
